unit Unit1;

{
 search for number that is divided by a factor (f) if
 the left-most digit is moved right of the number.

 This left-most digit is selectable just as the factor.

 The search starts with the selected digit in array A[0]
 Then A[0] is multiplied by f, the result stored in A[1], carry to A[2]...etc
 Next a[1] is multiplied by f etc.
 This iterative search stops when A[N] = A[0]
 The final result is A[N]..A[1] , this number is displayed.

 During step mode the process is showed step by step.
 Carries are painted in red.

 A button is added to place the result on the clipboard.
 This allows for export to text editors.
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    StaticText1: TStaticText;
    N0upDown: TUpDown;
    Label1: TLabel;
    GObtn: TButton;
    msgText: TStaticText;
    StaticText3: TStaticText;
    FactorUpDown: TUpDown;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    stepmodeCheckbox: TCheckBox;
    clipbtn: TButton;
    Label6: TLabel;
    procedure GObtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure clipbtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses clipbrd;

const maxN = 120;

var A : array[0..maxN] of byte;
    stopFlag : boolean;

procedure displayA(n : byte);
//n is number of digits
//digits before p are carries and are painted red
var i,p,w : byte;
    x : smallInt;
    ch : char;
begin
 with form1.PaintBox1 do with canvas do
  begin
   brush.color := $ffffff;
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
  end;
 p := maxN;
 while (A[p] = 0) and (p > 0) do dec(p);
 form1.label4.Caption := inttostr(p);
 with form1.PaintBox1 do with Canvas do
  begin
   w := textwidth('M');
   brush.Style := bsClear;
   x := width -5 - w;
   for i := 1 to p do begin
                       if i > n then font.Color := $ff
                        else font.color := 0;
                       ch := Char(A[i]+ord('0'));
                       textout(x,3,ch);
                       x := x - w;
                      end;
  end;
end;

procedure TForm1.GObtnClick(Sender: TObject);
var carry,i,f,h,N : byte;
    hit : boolean;
begin
 activecontrol := nil;
 for i := 0 to maxN do A[i] := 0;
 displayA(0);
 A[0] := N0upDown.Position;  //starting digit
 f := factorUpdown.Position; //factor
//--
 N := 0;
 repeat
  inc(N);
  A[N] := A[N-1]*f + A[N];
  h := 0;
  while A[N+h] >= 10 do
   begin
    carry := A[N+h] div 10;
    A[N+h] := A[N+h] mod 10;
    inc(h);
    A[N+h] := A[n+h] + carry;
   end;
  hit := (A[N] = A[0]) and (h=0);
  if hit then  stepModeCheckbox.checked := false;
//--
  if stepModecheckbox.Checked then
   begin
    stopFlag := true;
    msgText.Caption := 'stop. <space> to step, <cr> to finish';
    displayA(N);
    while stopFlag do application.ProcessMessages;
   end;
 until (N = maxN) or hit;
//--
 if hit then begin
              msgText.Caption := 'solution';
              displayA(N);
             end
  else begin
        msgText.Caption := 'no solution';
        label4.Caption := '';
       end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 label3.Caption := 'number will be <factor> times smaller '+
                   'if first digit is placed right';
end;

procedure TForm1.FormPaint(Sender: TObject);
//edges around paintbox
var x1,y1,x2,y2 : word;
begin
 with paintbox1 do
  begin
   x1 := left - 1;
   y1 := top - 1;
   x2 := left + width;
   y2 := top + height;
  end;
 with canvas do
  begin
   pen.Width := 1;
   pen.color := 0;
   moveto(x1,y1);
   lineto(x1,y2);
   lineto(x2,y2);
   lineto(x2,y1);
   lineto(x1,y1);
  end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 case key of
  VK_RETURN : begin
               stepmodecheckbox.Checked := false;
               stopFlag := false;
              end;
  VK_space  : stopFlag := false;
  end;//case;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 stopflag := false;
 stepmodecheckbox.Checked := false;
end;

procedure TForm1.clipbtnClick(Sender: TObject);
//save result to clipboard
//make format xxx.xxx.xxx.xxx
var s : string;
    i,n,p : byte;
begin
 s := '';
 n := maxN;
 while (A[n] = 0) and (n > 0) do dec(n);
 p := 0;
 for i := n downto 1 do
  begin
   if p = 3 then begin
                  s := s + '.';
                  p := 0;
                 end;
   s := s + char(A[i] + ord('0'));
   inc(p);
  end;
 clipboard.AsText := s;
 msgtext.caption := 'result saved to clipboard';
end;

end.
